var focused = 2, 
	timeUnfocused = 0, 
	autopaste_enabled = false, 
	autopaste_value = '',
	autoclose_enabled = false, 
	autoclose_timer = 60;

function get_pastedtext() {
	var input = document.createElement('input');
	input.style.position = 'fixed';
	input.style.top = '0';
	document.body.appendChild(input);
	input.focus({preventScroll: true});
	document.execCommand('paste');
	var pastedtext = input.value;
	input.remove();
	pastedtext = pastedtext.replace('Nick: ','');
	return pastedtext;
}

function timefunc() {
	setTimeout(timefunc, 1e3);

	var sh = document.getElementById('sh_autopaste_search');
	if(!sh) return;

	var hasFocus = document.hasFocus();
	if(autoclose_enabled && autoclose_timer) {
		if(!hasFocus) ++timeUnfocused;
		else timeUnfocused = 0;

		if(timeUnfocused >= autoclose_timer) {
			chrome.runtime.sendMessage(null, {close: true});
		}
	}
	
	if(autopaste_enabled && (!hasFocus || focused == 2)) {
		var pastedtext = get_pastedtext();

		if(pastedtext != autopaste_value) {
			chrome.storage.local.set({sh_pasteval: pastedtext});

			sh.value = pastedtext;
			sh.dispatchEvent(new Event('change'));
		}
		if(focused == 2) focused = 1;
	} else {
		//console.log('focused');
	}
}

chrome.storage.onChanged.addListener(function(changes, areaName) {
	if(areaName != 'local') return;

	if(changes.hasOwnProperty('sh_autopaste_enabled')) autopaste_enabled = changes['sh_autopaste_enabled'].newValue;
	else if(changes.hasOwnProperty('sh_autoclose_enabled')) autoclose_enabled = changes['sh_autoclose_enabled'].newValue;
	else if(changes.hasOwnProperty('sh_autoclose_timer')) autoclose_timer = +changes['sh_autoclose_timer'].newValue;
	else if(changes.hasOwnProperty('sh_pasteval')) autopaste_value = changes['sh_pasteval'].newValue;
});

chrome.storage.local.get(['sh_autopaste_enabled', 'sh_pasteval', 'sh_autoclose_enabled', 'sh_autoclose_timer'], function(result) {
	if(result.sh_pasteval) autopaste_value = result.sh_pasteval;
	if(result.sh_autopaste_enabled) autopaste_enabled = true;
	if(result.sh_autoclose_enabled) autoclose_enabled = true;
	if(result.hasOwnProperty('sh_autoclose_timer')) autoclose_timer = +result.sh_autoclose_timer;

	timefunc();
});
